﻿// SearchDlg.cpp : 구현 파일입니다.
#include "stdafx.h"
#include "NeMessenger.h"
#include "SearchDlg.h"
#include "NeMessengerDlg.h"

// CSearchDlg 대화 상자입니다.

#define TAB_HEADER_HEIGHT		30

const TCHAR *lpszListHeader[] = {	
	_T(""),				//0
	_T("이름"),			//1
	_T("소속"),			//2
	_T("직위"),			//3
	_T("직책"),			//4
	_T("회사전화"),		//5
	_T("팩스번호"),		//6
	_T("휴대폰"),		//7
	_T("내선번호"),		//8
	_T("E-mail"),		//9
	_T("로밍폰"),		//10
	_T("키워드"),		//11
	_T("도시"),			//12
	_T(""),				//13  컬럼을 숨기고 키값인 userid를 넣는다.
	NULL};	

	const int nColWidthList[] = {
		40,		//0
		50,		//1
		50,		//2
		50,		//3
		50,		//4
		90,		//5
		90,		//6
		90,		//7
		90,		//8
		90,		//9
		90,		//10
		90,		//11		
		90,		//12
		0,//13
	};	

IMPLEMENT_DYNAMIC(CSearchDlg, CSkinDialog)

CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
	: CSkinDialog(CSearchDlg::IDD, pParent)
{
		m_pChatDlg = NULL;
}

CSearchDlg::~CSearchDlg()
{
	
}

void CSearchDlg::InitList(CListCtrlOrg &list, const TCHAR**pszTitle)
{
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT /*| LVCF_WIDTH | LVCF_IMAGE*/;
	for( int i=0; ; i++ )
	{
		if( pszTitle[i] == NULL )
			break;

		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (TCHAR *)pszTitle[i];
		lvcolumn.iSubItem = i;
		list.InsertColumn(i, &lvcolumn);
	}	

	lvcolumn.pszText = (TCHAR *)pszTitle[0];
	lvcolumn.iSubItem = 0;
	list.SetColumn(0, &lvcolumn);
	list.SetExtendedStyle(LVS_EX_FULLROWSELECT/*| LVS_EX_GRIDLINES | LVS_EX_FLATSB | LVS_EX_SUBITEMIMAGES*/);
	list.EnableToolTips(FALSE);
	// 리스트 아이템 높이 설정
	list.SetRowHeight(20);
	// 리스트 폰트 설정
	list.SetTextFont(&g_ftNanumSize8 );
	// 언더라인 컬러 설정
	list.SetUnderLine(FALSE);
	//// 헤더 높이 설정
	//list.m_HeaderCtrl.SetHeight(20);
	// 헤더 폰트 설정
	list.m_HeaderCtrl.SetTextFont(&g_ftNanumSize8);
}


void CSearchDlg::ResizeListColumn(CListCtrlOrg &list, const int *arrWidth)
{
	SCROLLINFO si;
	CRect rc;
	list.GetWindowRect(&rc);
	int nMargin=0;

	// 스크롤 유무에 따른 마진 추가
	list.GetScrollInfo(SB_VERT, &si);	
	if( si.nPage && si.nPage <= (UINT)si.nMax ) 
	{
		nMargin = ::GetSystemMetrics(SM_CXVSCROLL);
	}

	// 보더 유무에 따른 마진 추가
	DWORD dwExStyle = list.GetExStyle();
	if( dwExStyle&WS_EX_STATICEDGE || 
		dwExStyle&WS_EX_CLIENTEDGE )
	{
		nMargin += ::GetSystemMetrics(SM_CXEDGE)*2;
	}

	
	int nResizeMaginWidth =(rc.Width()-nMargin)- list.m_nInitWidth;

	for( int i=0; ; i++ )
	{
		//Trace(_T("SetColumm i %d width = %d \n"),i,arrWidth[i]);
		// 마지막 컬럼일 경우
		if (i==0 || i==12) // 리사이징이 안 할 컬럼들
		{
			list.SetColumnWidth(i,arrWidth[i]);
		}
		else
		{
			list.SetColumnWidth(i, arrWidth[i] + (nResizeMaginWidth/10));
			//Trace(_T("SetColumm i %d width = %d \n"),i,arrWidth[i]);
		}
		if (arrWidth[i] == 0)
		{
			break;
		}

	}
	list.RedrawWindow();

}


BOOL CSearchDlg::Create(LPCTSTR pszSearchText, LPCTSTR pszCondition, UINT nIDTemplate, CWnd* pParentWnd)
{
	m_strInitSearchText=pszSearchText;
	m_strInitCondition=pszCondition;
//	Trace(_T("2m_strInitSearchText = %s , m_strInitCondition = %s \n"),m_strInitSearchText, m_strInitCondition);
	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}
void CSearchDlg::DoDataExchange(CDataExchange* pDX)
 {
	 CSkinDialog::DoDataExchange(pDX);

	 DDX_Control(pDX, IDC_EDIT_SEARCH_CONDITION, m_edSeachText);
	 DDX_Control(pDX, IDC_COMBO_SEARCH_CONDITION, m_cmbSearchCondition);
	 DDX_Control(pDX, IDC_BUTTON_SEARCH,m_btnSearch);
	 DDX_Control(pDX, IDC_BUTTON_FAVORITE_ADD, m_btnFavoriteAdd);
	 DDX_Control(pDX, IDC_BUTTON_IM_INVITE, m_btnIMInvite);
	 DDX_Control(pDX, IDC_BUTTON_RECIPENT_ADD, m_btnRecipentAdd);
	 DDX_Control(pDX, IDC_LIST_SEARCH_RESULT, m_lcResult);
	 DDX_Text(pDX,IDC_EDIT_SEARCH_CONDITION, m_strSearchText);

	 DDX_Control(pDX, IDC_BUTTON_SEARCH, m_btnSearch);
	 
}


BEGIN_MESSAGE_MAP(CSearchDlg, CSkinDialog)
	ON_BN_CLICKED(IDC_BUTTON_FAVORITE_ADD, &CSearchDlg::OnBnClickedButtonFavoriteAdd)
	ON_BN_CLICKED(IDC_BUTTON_IM_INVITE, &CSearchDlg::OnBnClickedButtonImInvite)
	ON_BN_CLICKED(IDC_BUTTON_RECIPENT_ADD, &CSearchDlg::OnBnClickedButtonRecipentAdd)
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, &CSearchDlg::OnBnClickedButtonSearch)
//	ON_WM_NCHITTEST()
	ON_NOTIFY(NM_CLICK, IDC_LIST_SEARCH_RESULT, &CSearchDlg::OnNMClickListSearchResult)
	ON_NOTIFY(NM_RCLICK, IDC_LIST_SEARCH_RESULT, &CSearchDlg::OnNMRClickListSearchResult)
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, &CSearchDlg::OnBnClickedCloseButton)
	ON_BN_CLICKED(IDC_MAX_BUTTON, &CSearchDlg::OnBnClickedMaxButton)
	ON_BN_CLICKED(IDC_MIN_BUTTON, &CSearchDlg::OnBnClickedMinButton)
	ON_COMMAND(ID_32833, &CSearchDlg::OnMnProfile)
	ON_COMMAND(ID_32834, &CSearchDlg::OnMnIMInvite)
	ON_COMMAND(ID_32835, &CSearchDlg::OnMnSendMemo)
	ON_COMMAND_RANGE(WM_USER_RESULT_MENU,(WM_USER_RESULT_MENU + 100),OnMenuResultListFavoriteAdd)
	ON_COMMAND_RANGE(WM_USER_FAVORITE_ADD,(WM_USER_FAVORITE_ADD + 100),OnMenuListFavoriteAdd)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_NCLBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_NOTIFY(LVN_BEGINRDRAG, IDC_LIST_SEARCH_RESULT, &CSearchDlg::OnLvnBeginrdragListSearchResult)
END_MESSAGE_MAP()

BOOL CSearchDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();


	ModifyStyle(0, WS_CLIPCHILDREN);
	//SetWindowRegion();
	InitList(m_lcResult,lpszListHeader);
	ResizeListColumn(m_lcResult, nColWidthList);




	__ResourceLoad(TRUE);

	g_pMessengerActor->RegisterObserver(this);
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RegisterObserver(this);
	
	m_pImageList= new CImageList();
	if (!m_pImageList->Create(16,16,ILC_COLOR32 | ILC_COLOR | ILC_MASK,3,3))
	{
		delete m_pImageList;
		m_pImageList = NULL;
	}
	else
	{
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_OFFLINE));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_ONLINE));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_AFK));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_OTHERBUSY));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_STEPOUT));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_TELBUSY));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_EATBUSY));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_MEETBUSY));
		m_pImageList->Add(AfxGetApp()->LoadIcon(IDI_IC_OFFLINE));
	}
	m_lcResult.SetImageList(m_pImageList,LVSIL_NORMAL);

	_clipBoardFormat = RegisterClipboardFormat(_T("Remote_Setup"));
//	ResizeCtrl();
//	::RedrawWindow(m_hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME);
	SetWindowMinSize(385, 315);
	SetMoveTransParent(FALSE); //윈도우 이동시 투명하게 하지 않기	
	

//	SendMessage(WM_SIZE, 700, 375);
	ResizeCtrl();
	RedrawWindow();
	m_edSeachText.SetWindowText(m_strInitSearchText);
	trid_t trid(SEARCH_BASE_TRID);
	Trace(_T("m_strInitSearchText = %s , m_strInitCondition = %s \n"),m_strInitSearchText, m_strInitCondition);
	pWASActor->RequestNameSearchList(m_strInitSearchText,m_strInitCondition,&trid);


	return TRUE;
}

void CSearchDlg::__ResourceLoad(BOOL bInit)
{	
	CString strRes;
	int nCurSel = 0;
	if(bInit==TRUE)
	{
		strRes.LoadStringW(IDS_STRING146);
		m_cmbSearchCondition.AddString(strRes);
		strRes.LoadStringW(IDS_STRING147);
		m_cmbSearchCondition.AddString(strRes);
		strRes.LoadStringW(IDS_STRING148);
		m_cmbSearchCondition.AddString(strRes);
		m_cmbSearchCondition.SetCurSel(0);
		m_cmbSearchCondition.SetFont(&g_ftNanumSize8);
		m_cmbSearchCondition.MoveWindow(490,34,72,22,TRUE);
		m_edSeachText.MoveWindow(567,34,204,22,TRUE);
		m_btnSearch.MoveWindow(774,34,13,22,TRUE);
		m_btnFavoriteAdd.MoveWindow(601,316,57,22,TRUE);
		m_btnIMInvite.MoveWindow(661,316,56,22,TRUE);
		m_btnRecipentAdd.MoveWindow(721,316,71,22,TRUE);
	}
	else
	{

	}


	if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{
		m_btnFavoriteAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\favorite_add_button_temp.bmp"),RGB(0,0,0));
		m_btnIMInvite.SetBtnBitmapFile(_T("IMAGES\\controlskin\\im_button_temp.bmp"),RGB(0,0,0));
		m_btnRecipentAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\memosend_button_temp.bmp"),RGB(0,0,0));
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{
		m_btnFavoriteAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\favorite_add_button_temp_en.bmp"),RGB(0,0,0));
		m_btnIMInvite.SetBtnBitmapFile(_T("IMAGES\\controlskin\\im_button_temp_en.bmp"),RGB(0,0,0));
		m_btnRecipentAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\memosend_button_temp_en.bmp"),RGB(0,0,0));
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
		m_btnFavoriteAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\favorite_add_button_temp_jp.bmp"),RGB(0,0,0));
		m_btnIMInvite.SetBtnBitmapFile(_T("IMAGES\\controlskin\\im_button_temp_jp.bmp"),RGB(0,0,0));
		m_btnRecipentAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\memosend_button_temp_jp.bmp"),RGB(0,0,0));
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
		m_btnFavoriteAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\favorite_add_button_temp_cn-b.bmp"),RGB(0,0,0));
		m_btnIMInvite.SetBtnBitmapFile(_T("IMAGES\\controlskin\\im_button_temp_cn-b.bmp"),RGB(0,0,0));
		m_btnRecipentAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\memosend_button_temp_cn-b.bmp"),RGB(0,0,0));
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
		m_btnFavoriteAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\favorite_add_button_temp_cn-g.bmp"),RGB(0,0,0));
		m_btnIMInvite.SetBtnBitmapFile(_T("IMAGES\\controlskin\\im_button_temp_cn-g.bmp"),RGB(0,0,0));
		m_btnRecipentAdd.SetBtnBitmapFile(_T("IMAGES\\controlskin\\memosend_button_temp_cn-g.bmp"),RGB(0,0,0));
	}

	m_btnSearch.SetBtnBitmapFile(_T("IMAGES\\controlskin\\search_button.bmp"),RGB(0,0,0));

	SetLeftTopBitmap(_T("IMAGES\\06_top_left.bmp"));
	SetCenterTopBitmap(_T("IMAGES\\06_top.bmp"));
	SetRightTopBitmap(_T("IMAGES\\06_top_right.bmp"));

	SetLeftBorderBitmap(_T("IMAGES\\06_left.bmp"));
	SetRightBorderBitmap(_T("IMAGES\\06_right.bmp"));

	SetLeftBottomBitmap(_T("IMAGES\\06_bottom_left.bmp"));
	SetCenterBottomBitmap(_T("IMAGES\\06_bottom.bmp"));
	SetRightBottomBitmap(_T("IMAGES\\06_bottom_right.bmp"));

	SetRestoreBitmaps(_T("IMAGES\\controlskin\\restore.bmp"), _T("IMAGES\\controlskin\\restore_over.bmp"), _T("IMAGES\\controlskin\\restore_click.bmp"));
	SetMaxBitmaps(_T("IMAGES\\controlskin\\max.bmp"), _T("IMAGES\\controlskin\\max_over.bmp"), _T("IMAGES\\controlskin\\max_click.bmp"));
	SetMinBitmaps(_T("IMAGES\\controlskin\\min.bmp"), _T("IMAGES\\controlskin\\min_over.bmp"), _T("IMAGES\\controlskin\\min_click.bmp"));
	SetExitBitmaps(_T("IMAGES\\controlskin\\close.bmp"), _T("IMAGES\\controlskin\\close_over.bmp"), _T("controlskin\\close_click.bmp"));


	if(bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}
void CSearchDlg::SetCharDlgPtr(CChatDlg* pDlg)
{
	m_pChatDlg = pDlg;
	if (m_pChatDlg)
		m_pChatDlg->m_DT.setClipBoardFormat(_clipBoardFormat);
}

// CSearchDlg 메시지 처리기입니다.

void CSearchDlg::OnBnClickedButtonFavoriteAdd()
{

	CRect rectTopMenu;

	CMenu menuTop;
	menuTop.LoadMenuW(IDR_MEMU_COMMON_MENU);

	CButton *pTopMenu = (CButton*)GetDlgItem(IDC_BUTTON_FAVORITE_ADD);
	pTopMenu->GetWindowRect(&rectTopMenu);

	CMenu *pSubMenu = menuTop.GetSubMenu(6);

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	{
		for(size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

			CString strGroupName = pGroup->GetName();
			int nGroupID = pGroup->GetID();			
			m_GroupList.insert(std::make_pair(WM_USER_FAVORITE_ADD + i, nGroupID));
			pSubMenu->InsertMenu(i,MF_BYPOSITION,WM_USER_FAVORITE_ADD + i,strGroupName);
		}
	}
	pSubMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, rectTopMenu.left, rectTopMenu.bottom - 1, this);
}

void CSearchDlg::OnBnClickedButtonImInvite()
{
	OnMnIMInvite();
}

void CSearchDlg::OnBnClickedButtonRecipentAdd()
{
	OnMnSendMemo();
}

void CSearchDlg::OnBnClickedButtonSearch()
{
	UpdateData(TRUE);

	CString strWhere;
	int nSearchCondition = m_cmbSearchCondition.GetCurSel();
	switch(nSearchCondition)
	{
	case 0:
		strWhere = _T("emp_nm|dept_nm");//이름 소속
		break;
	case 1:
		strWhere = _T("jbps_nm|jbdt_nm");
		break;
	case 2:
		strWhere = _T("inco_tel_no|fax_no|cph_no|ipph_no|email_addr|rmngph_no|kwd_nm");
		break;
	}

	CString strKeyword=_T("");
	m_edSeachText.GetWindowText(strKeyword);

	if (m_edSeachText.GetWindowTextLength()<2)
	{
		NMMessageBox(_T("두글자 이상 입력하세요"));
		return;
	}

	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid(SEARCH_BASE_TRID);
	pWASActor->RequestNameSearchList(strKeyword,strWhere,&trid);

}

void CSearchDlg::OnNMClickListSearchResult(NMHDR *pNMHDR, LRESULT *pResult)
{

}

void CSearchDlg::OnNMRClickListSearchResult(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	CPoint pt;
	GetCursorPos(&pt);
	CMenu menuList;
	menuList.LoadMenu(IDR_MEMU_COMMON_MENU);

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	{
		Trace(_T("nGroup Conut = %d\n"),nGroupCount);
		for(size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

			CString strGroupName = pGroup->GetName();
			int nGroupID = pGroup->GetID();
			m_GroupList.insert(std::make_pair(WM_USER_RESULT_MENU + i, nGroupID));

			CMenu* pPopup = menuList.GetSubMenu(7)->GetSubMenu(3);
			pPopup->InsertMenu(i,MF_BYPOSITION,WM_USER_RESULT_MENU + i,strGroupName);
			TRACE(_T("MakeFavoriteMenu GroupID = %d \n"),nGroupID);	
		}
	}

	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	//일단 한명일때만 채팅메뉴를 Disable 시켜준다.
	//다중일때는 기획문의 후 수정하자!
	if(nSelectCount==1)
	{
		int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);
		int nImage = m_lcResult.GetItemImage(nSelectedIndex, 0);
		if( nImage == 0 )
		{
			menuList.EnableMenuItem(ID_32834, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			m_btnIMInvite.SetButtonDisable();
		}
		else
			m_btnIMInvite.SetButtonEnable();
	}
	menuList.GetSubMenu(7)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x,pt.y,this);

	*pResult = 0;

}

BOOL CSearchDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: 여기에 특수화된 코드를 추가 및/또는 기본 클래스를 호출합니다.
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			OnBnClickedButtonSearch();
			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		this->DestroyWindow();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}
/*
LRESULT CSearchDlg::OnNcHitTest(CPoint point)
{
	// TODO: 여기에 메시지 처리기 코드를 추가 및/또는 기본값을 호출합니다.

	return HTCAPTION;
}
*/
void CSearchDlg::OnBnClickedCloseButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	CSkinDialog::OnOK();
}

void CSearchDlg::OnBnClickedMaxButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}

void CSearchDlg::OnBnClickedMinButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


//////////

bool CSearchDlg::OnGTWASActor_ResponseNameSearchList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list)
{
	if(trid.GetID()!=SEARCH_BASE_TRID)
	{
		return False;
	}
	m_lcResult.DeleteAllItems();
	if(list.nSize<1)
	{
		//NMMessageBox(_T("검색결과가 없습니다"));
		return false;
	}
	vector<wstring> vecUsers;
	for(size_t i = 0; i < list.nSize; i++)
	{
		const NE_MEMBER_DATA &sMemberInfo = list.pList[i];
		m_lcResult.InsertItem(i,_T(""));
		m_lcResult.SetItemImage(i, 0, 0, TRUE);
		//m_lcResult.SetItemText(i,0,sMemberInfo.strUserId.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,1,sMemberInfo.strName.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,2,sMemberInfo.strDept.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,3,sMemberInfo.strJobPos.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,4,sMemberInfo.strJobDuty.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,5,sMemberInfo.strIncoTel.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,6,sMemberInfo.strFaxNum.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,7,sMemberInfo.strCellPhone.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,8,sMemberInfo.strExtesion.c_str(),RGB(68,68,68), RGB(255,255,255)); //내선번호 추가
		m_lcResult.SetItemText(i,9,sMemberInfo.strEmail.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,10,sMemberInfo.strRmngPhone.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,11,sMemberInfo.strKeyword.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,12,sMemberInfo.strWorkPlace.c_str(),RGB(68,68,68), RGB(255,255,255));
		m_lcResult.SetItemText(i,13,sMemberInfo.strUserId.c_str(),RGB(255,255,255), RGB(255,255,255));
		vecUsers.push_back(sMemberInfo.strUserId);
	}
	g_pMessengerActor->RequestCheckStatus(vecUsers, 2, true);
	return true;
}
void CSearchDlg::OnMnProfile()
{
	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	if(nSelectCount<0)
	{
		NMMessageBox(_T("선택된 상대가 없습니다"));
	}

	CNeMessengerApp* pParent = (CNeMessengerApp*)AfxGetApp();
	while (pos)
	{
		int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);
		CString strID=	m_lcResult.GetItemText(nSelectedIndex,13);
		CProfileDlg *pDlg = new CProfileDlg();
		pDlg->Create(strID, pParent->m_listProfileDlg.GetCount(), CProfileDlg::IDD,this);		
		pDlg->SetTitle(_T("대화상대 정보"));
	//	pDlg->RequestInfo();
		//SetWindowPosToSide(this, pDlg);
		pDlg->ShowWindow(SW_SHOW);
		pParent->m_listProfileDlg.AddTail((CObject*)pDlg);
		//프로필 보기
	}
}

void CSearchDlg::OnMnIMInvite()
{
	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	if(nSelectCount>0)
	{


		std::vector<NE_MEMBER_DATA> sTemp;
		NE_MEMBER_DATA sResultPrivate;
		sTemp.clear();
		CStringArray arrUser;
		while (pos)
		{
			int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);

			int nImage = m_lcResult.GetItemImage(nSelectedIndex, 0);
			if( nImage == 0 )
				continue;

			CString strID=	m_lcResult.GetItemText(nSelectedIndex,13);
			sResultPrivate.strUserId = strID;
			sTemp.push_back(sResultPrivate);

			arrUser.Add(strID);
		}
		if (GET_MAIN_DLG()->GetSafeHwnd())
		{
			GET_MAIN_DLG()->SendMessage(WM_MAKECHATDLG, 0, (LPARAM)&arrUser);
		}
	}
}

void CSearchDlg::OnMnSendMemo()
{
	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	if(nSelectCount>0)
	{
		CStringArray arrUser;
		while (pos)
		{
			int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);
			CString strID=	m_lcResult.GetItemText(nSelectedIndex,13);
			arrUser.Add(strID);
		}
		if (GET_MAIN_DLG()->GetSafeHwnd())
		{
			GET_MAIN_DLG()->SendMessage(WM_MAKESENDMEMODLG, 0, (LPARAM)&arrUser);
		}
	}

}
void CSearchDlg::OnMenuResultListFavoriteAdd(WPARAM wParam)
{

	int nID =(int)wParam;
	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
	int nGroupID = iter->second;

	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	if(nSelectCount<1)
	{
		NMMessageBox(_T("선택된 상대가 없습니다"));
		return;
	}

	std::vector<wstring> vecBuddyId;
	while (pos)
	{
		int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);
		CString strID=	m_lcResult.GetItemText(nSelectedIndex,13);

		CString strSubText;
		AfxExtractSubString(strSubText, strID, 0, '@');
		if (g_stNtalkInfo.strId == (CString)strSubText)
			continue;

		vecBuddyId.push_back((LPCWSTR)strID);
	}

	if( vecBuddyId.empty() != true )
		AddFavoriteList(vecBuddyId, nGroupID);
}

BOOL CSearchDlg::AddFavoriteList(std::vector<wstring> &vecBuddyId, int nGroupID)
{
	if(g_pMessengerActor->RequestAddBuddy(nGroupID, vecBuddyId, _T("")) == false)
		return FALSE;
	return TRUE;
}

void CSearchDlg::OnMenuListFavoriteAdd(WPARAM wParam)
{
	int nID =(int)wParam;
	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
	int nGroupID = iter->second;

	int nSelectCount = m_lcResult.GetSelectedCount();
	POSITION pos = m_lcResult.GetFirstSelectedItemPosition();
	if(nSelectCount<1)
	{
		CString strString;
		strString.LoadStringW(IDS_STRING218);
		NMMessageBox(strString);
	}

	std::vector<wstring> vecBuddyId;
	while (pos)
	{
		int nSelectedIndex = m_lcResult.GetNextSelectedItem(pos);
		CString strID =	m_lcResult.GetItemText(nSelectedIndex,13);

		CString strSubText;
		AfxExtractSubString(strSubText, strID, 0, '@');
		if (g_stNtalkInfo.strId == (CString)strSubText)
			continue;

		vecBuddyId.push_back((LPCWSTR)strID);
	}

	if( vecBuddyId.empty() != true )
		AddFavoriteList(vecBuddyId, nGroupID);
}

void CSearchDlg::OnDestroy()
{
	__super::OnDestroy();	
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->UnRegisterObserver(this);
	g_pMessengerActor->UnRegisterObserver(this);
}

void CSearchDlg::ResizeCtrl(void)
{
	CRect rcClient;
	GetClientRect(&rcClient);
	
	m_rcImage.left = rcClient.left;
	m_rcImage.right = rcClient.right;
	m_rcImage.bottom = rcClient.bottom;
	m_rcImage.top = m_rcImage.bottom - 49;

	CRect rcbtnSearch;
	m_btnSearch.GetWindowRect(&rcbtnSearch);
	int cx = rcbtnSearch.Width();
	int cy = rcbtnSearch.Height();
	rcbtnSearch.right = rcClient.right;
	rcbtnSearch.left  = rcbtnSearch.right - cx;
	rcbtnSearch.top   = rcClient.top + 5;
	rcbtnSearch.bottom = rcbtnSearch.top + cy;
	m_btnSearch.MoveWindow(rcbtnSearch, TRUE);

	CRect rceditSearch;
	m_edSeachText.GetWindowRect(&rceditSearch);
	cx = rceditSearch.Width();
	cy = rceditSearch.Height();
	rceditSearch.right = rcbtnSearch.left;
	rceditSearch.left = rceditSearch.right - cx;
	rceditSearch.top  = rcbtnSearch.top;
	rceditSearch.bottom = rceditSearch.top + cy;
	m_edSeachText.MoveWindow(rceditSearch, TRUE);

	CRect rccombo;
	m_cmbSearchCondition.GetWindowRect(&rccombo);
	cx = rccombo.Width();
	cy = rccombo.Height();
	rccombo.right = rceditSearch.left - 5;
	rccombo.left  = rccombo.right - cx;
	rccombo.top   = rcbtnSearch.top;
	rccombo.bottom = rccombo.top + cy;
	m_cmbSearchCondition.MoveWindow(rccombo, TRUE);

	CRect rcbtnRecipent;
	m_btnRecipentAdd.GetWindowRect(&rcbtnRecipent);
	cx = rcbtnRecipent.Width();
	cy = rcbtnRecipent.Height();
	rcbtnRecipent.right = rcClient.right;
	rcbtnRecipent.left = rcbtnRecipent.right - cx;
	rcbtnRecipent.bottom = m_rcImage.top - 10;
	rcbtnRecipent.top = rcbtnRecipent.bottom - cy;
	m_btnRecipentAdd.MoveWindow(rcbtnRecipent, TRUE);

	CRect rcInvit;
	m_btnIMInvite.GetWindowRect(&rcInvit);
	cx = rcInvit.Width();
	cy = rcInvit.Height();
	rcInvit.right = rcbtnRecipent.left - 3;
	rcInvit.left  = rcInvit.right - cx;
	rcInvit.top   = rcbtnRecipent.top;
	rcInvit.bottom = rcbtnRecipent.bottom;
	m_btnIMInvite.MoveWindow(rcInvit, TRUE);

	CRect rcbtnFavorite;
	m_btnFavoriteAdd.GetWindowRect(&rcbtnFavorite);
	cx = rcbtnFavorite.Width();
	cy = rcbtnFavorite.Height();
	rcbtnFavorite.right = rcInvit.left - 3;
	rcbtnFavorite.left  = rcbtnFavorite.right - cx;
	rcbtnFavorite.top   = rcbtnRecipent.top;
	rcbtnFavorite.bottom = rcbtnRecipent.bottom;
	m_btnFavoriteAdd.MoveWindow(rcbtnFavorite, TRUE);


	CRect rcResult;	
	rcResult.left = rcClient.left;
	rcResult.right = rcClient.right;
	rcResult.top = rceditSearch.bottom + 6;
	rcResult.bottom = rcbtnFavorite.top - 10;
	m_lcResult.MoveWindow(rcResult, TRUE);
	ResizeListColumn(m_lcResult, nColWidthList);	
}

void CSearchDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);
	RedrawWindow();
	ResizeCtrl();
//	Invalidate(FALSE);
}

void CSearchDlg::OnPaint()
{		
	// 그리기 메시지에 대해서는 __super::OnPaint()을(를) 호출하지 마십시오.
	CPaintDC dc(this);
	CDC memDC;
	CBitmap newBmp, *pOldBmp;
	CRect rcClient;
	GetClientRect(&rcClient);
	memDC.CreateCompatibleDC(&dc);
	newBmp.CreateCompatibleBitmap(&dc, rcClient.Width(), rcClient.Height());
	pOldBmp = memDC.SelectObject(&newBmp);

	m_rcImage.left = rcClient.left;
	m_rcImage.right = rcClient.right;
	m_rcImage.bottom = rcClient.bottom;
	m_rcImage.top = m_rcImage.bottom - 49;

	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(241, 241, 241));

	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOldBmp);


	CBitmap bmBottom, *pOldbmBottom;

	LoadBitmapFromPath(bmBottom, _T("IMAGES\\kor\\search\\search_body_bottom.png"));
	pOldbmBottom = memDC.SelectObject(&bmBottom);
	dc.BitBlt(0, m_rcImage.top , 792, 49, &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOldbmBottom);


	CBitmap bmBottomCenter, *pOldbmBottomCenter;
	LoadBitmapFromPath(bmBottomCenter, _T("IMAGES\\kor\\search\\search_body_bottom_center.png"));
	pOldbmBottomCenter = memDC.SelectObject(&bmBottomCenter);
	int cx = rcClient.Width() - 794;
	dc.StretchBlt(792, m_rcImage.top, cx, 49, &memDC, 0, 0, 31, 49, SRCCOPY);

	memDC.SelectObject(pOldbmBottomCenter);

	CBitmap bmBottomRight, *pOldbmBottomRight;
	LoadBitmapFromPath(bmBottomRight, _T("IMAGES\\kor\\search\\search_body_bottom_right.png"));
	pOldbmBottomRight = memDC.SelectObject(&bmBottomRight);
	cx = rcClient.Width() - 2;
	dc.BitBlt(cx, m_rcImage.top, 2, 49, &memDC, 0, 0, SRCCOPY);


	memDC.SelectObject(pOldbmBottomRight);

	memDC.DeleteDC();

	bmBottomCenter.DeleteObject();
	bmBottomRight.DeleteObject();
	bmBottom.DeleteObject();
	newBmp.DeleteObject();
	CSkinDialog::OnPaint();	
}

BOOL CSearchDlg::OnEraseBkgnd(CDC* pDC)
{
	return __super::OnEraseBkgnd(pDC);
}
bool CSearchDlg::OnGTMessengerActor_UpdateNotBuddyUserStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nUserStatus)
{
	int nItemCount = m_lcResult.GetItemCount();
	for(int i = 0; i < nItemCount; i++)
	{
		CString strName = m_lcResult.GetItemText(i, 13);
		if(strName.Compare(strBuddyID) == 0)
		{
			OutputDebugString(_T("\r\nimage true"));				
			m_lcResult.SetItemImage(i, 0, nUserStatus, TRUE);
		}
	}

	return true;
}
void CSearchDlg::OnNcLButtonUp(UINT nHitTest, CPoint point)
{	
	Invalidate(FALSE);
	RedrawWindow();
	__super::OnNcLButtonUp(nHitTest, point);
}

void CSearchDlg::OnLButtonUp(UINT nFlags, CPoint point)
{	
	Invalidate(FALSE);
	RedrawWindow();
	__super::OnLButtonUp(nFlags, point);
}

void CSearchDlg::OnLvnBeginrdragListSearchResult(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	//// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	//
	//HGLOBAL m_hGlobal;

	//// Write to shared file
	//CSharedFile file;
	//CArchive ar(&file, CArchive::store);
	//ar<<_T("");
	//ar.Close();
	//_oleDataSource.CacheGlobalData(CF_HDROP, file.Detach()); 
	//_oleDataSource.SetClipboard();
	//_oleDataSource.DoDragDrop();

	*pResult = 0;
}
